SystemOrganization addCategory: #Growl!

TextMorph subclass: #GrowlMorph
	instanceVariableNames: 'dismissHandle vanishTime alpha actionBlock vanishDelay attr labelAttr contentsAttr'
	classVariableNames: 'DefaultBackgroundColor Position'
	poolDictionaries: ''
	category: 'Growl'!

!GrowlMorph commentStamp: 'TudorGirba 10/25/2011 17:14' prior: 0!
A GrowlMorph is a little Morph to announce event happening. Freely inspired from the MIT Snarl developed by  Tony Garnock-Jones. 

GrowlMorph new openInWorld

10 timesRepeat: [
	(GrowlMorph openWithLabel: 'The time' contents: TimeStamp now)
"		vanishDelay: 1000;
		resetVanishTimer".
	World doOneCycle ]

(GrowlMorph openWithLabel: 'The time' contents: TimeStamp now) 
	actionBlock: [Transcript open]!

!GrowlMorph class methodsFor: 'instance creation' stamp: 'StephaneDucasse 7/19/2011 19:36'!
contents: contentString
	
	^ self new
		label: '' contents: contentString;
		yourself! !

!GrowlMorph class methodsFor: 'instance creation' stamp: 'StephaneDucasse 7/19/2011 19:17'!
label: aString contents: contentString
	
	^ self new
		label: aString contents: contentString;
		yourself! !

!GrowlMorph class methodsFor: 'instance creation' stamp: 'StephaneDucasse 7/19/2011 19:38'!
openWithContents: contentString
	
	^ (self contents: contentString) openInWorld! !

!GrowlMorph class methodsFor: 'instance creation' stamp: 'StephaneDucasse 7/19/2011 19:38'!
openWithLabel: aString contents: contentString
	
	^ (self label: aString contents: contentString) openInWorld! !

!GrowlMorph class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/19/2012 23:36'!
openWithLabel: aString contents: contentString color: aColor
	
	^ (self label: aString contents: contentString)
			backgroundColor: aColor;
			openInWorld! !

!GrowlMorph class methodsFor: 'position' stamp: 'BenjaminVanRyseghem 3/2/2012 00:51'!
position

	^ Position ifNil: [ Position := #bottomLeft ]! !

!GrowlMorph class methodsFor: 'position' stamp: 'BenjaminVanRyseghem 3/2/2012 01:05'!
position: aSymbol

	(self possiblePositions includes: aSymbol) ifFalse: [ ^ self ].

	Position := aSymbol! !

!GrowlMorph class methodsFor: 'position' stamp: 'BenjaminVanRyseghem 3/2/2012 01:06'!
possiblePositions

	^ #( bottomRight bottomLeft topRight topLeft )! !

!GrowlMorph methodsFor: 'building' stamp: 'StephaneDucasse 7/19/2011 19:38'!
actionBlock: aBlock

	actionBlock := aBlock! !

!GrowlMorph methodsFor: 'accessing' stamp: 'StephaneDucasse 8/7/2011 17:02'!
alpha
	^ alpha
! !

!GrowlMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/1/2012 23:34'!
alpha: newAlpha

	"self alpha = newAlpha ifTrue: [^ self]."
	alpha := newAlpha.
	labelAttr color: (self labelColor alpha: alpha).
	contentsAttr color: (self labelColor alpha: alpha).
	self backgroundColor: (self nextColorStep: self backgroundColor).
	self allMorphsDo: [:m |
		m borderColor: (self nextColorStep: m borderColor).
		m color: (self nextColorStep: m color)].
	self borderColor isTransparent ifTrue: [self delete].! !

!GrowlMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/19/2012 23:34'!
backgroundColor

	^ backgroundColor ifNil: [ backgroundColor := self defaultBackgroundColor ]! !

!GrowlMorph methodsFor: 'building' stamp: 'StephaneDucasse 7/19/2011 18:56'!
contents: contentsString

	self streamDo: [ :w |
		w withAttributes: self contentsAttributes do: [w nextPutAll: contentsString asString]].! !

!GrowlMorph methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 3/2/2012 00:12'!
contentsAttributes
	^ { contentsAttr. TextAlignment centered. TextFontChange font2. }! !

!GrowlMorph methodsFor: 'accessing' stamp: 'TudorGirba 8/8/2011 11:24'!
contentsColor

	^ self theme growlContentsColorFor: self! !

!GrowlMorph methodsFor: 'initialize' stamp: 'TudorGirba 8/8/2011 11:32'!
createDismissHandle
	| handle |
	handle := self theme growlDismissHandleFor: self.
	handle on: #mouseUp send: #delete to: self.
	^ handle! !

!GrowlMorph methodsFor: 'default' stamp: 'TudorGirba 8/8/2011 11:21'!
defaultBackgroundColor

	^ self theme growlFillColorFor: self! !

!GrowlMorph methodsFor: 'default' stamp: 'TudorGirba 8/8/2011 11:22'!
defaultBorderColor
	
	^ self theme growlBorderColorFor: self! !

!GrowlMorph methodsFor: 'default' stamp: 'StephaneDucasse 7/16/2011 14:33'!
defaultTextStyle
	^ TextStyle actualTextStyles at: #Accuny! !

!GrowlMorph methodsFor: 'default' stamp: 'BenjaminVanRyseghem 3/1/2012 23:35'!
defaultVanishDelay
	
	^ 1  seconds! !

!GrowlMorph methodsFor: 'stepping' stamp: 'StephaneDucasse 7/19/2011 19:45'!
enabled

	^ false! !

!GrowlMorph methodsFor: 'interaction' stamp: 'StephaneDucasse 7/19/2011 19:32'!
handlesMouseDown: evt
	^ actionBlock notNil or: [super handlesMouseDown: evt]! !

!GrowlMorph methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 3/1/2012 23:53'!
initialize
	super initialize.

	self borderColor: self defaultBorderColor.
	self borderWidth: 2.
	self useRoundedCorners.
	self setProperty: #autoFitContents toValue: false.
	"self setTextStyle: self defaultTextStyle."
	self initializeLabelAttributes.
	self initializeContentsAttributes.
	self vanishDelay: self defaultVanishDelay.
	self label: 'A cool title' contents: 'Here an important message'.
	dismissHandle := self createDismissHandle.
	self addMorph: dismissHandle! !

!GrowlMorph methodsFor: 'initialize' stamp: 'StephaneDucasse 8/7/2011 18:10'!
initializeContentsAttributes
	contentsAttr := TextColor color: self contentsColor.
	! !

!GrowlMorph methodsFor: 'initialize' stamp: 'StephaneDucasse 8/7/2011 18:10'!
initializeLabelAttributes
	labelAttr := TextColor color: self labelColor.
	! !

!GrowlMorph methodsFor: 'internal' stamp: 'StephaneDucasse 7/19/2011 19:28'!
is: rect saneWithRespectTo: morphs
	morphs do: [:m |
		(m owner notNil and: [m bounds intersects: rect]) ifTrue: [^ false]].
	^ true! !

!GrowlMorph methodsFor: 'building' stamp: 'StephaneDucasse 8/7/2011 18:51'!
label: labelString contents: contentsString
	self streamDo: [ :w |
		w withAttributes:  self  labelAttributes do: [w nextPutAll: labelString asString; cr].
		w withAttributes: self contentsAttributes do: [w nextPutAll: contentsString asString].
		].! !

!GrowlMorph methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 3/2/2012 00:12'!
labelAttributes
	^ { labelAttr. TextAlignment centered. TextFontChange font4. TextEmphasis bold. }! !

!GrowlMorph methodsFor: 'accessing' stamp: 'TudorGirba 8/8/2011 11:26'!
labelColor
	^ self theme growlLabelColorFor: self! !

!GrowlMorph methodsFor: 'default' stamp: 'StephaneDucasse 8/7/2011 18:18'!
minimumExtent
	^ 256@38! !

!GrowlMorph methodsFor: 'interaction' stamp: 'StephaneDucasse 7/19/2011 19:35'!
mouseDown: evt
	super mouseDown: evt.
	evt yellowButtonPressed ifTrue: [^ self].
	actionBlock ifNotNil: [actionBlock valueWithPossibleArgs: { self }].! !

!GrowlMorph methodsFor: 'initialize' stamp: 'StephaneDucasse 7/19/2011 19:21'!
nextColorStep: aColor
	^ aColor alpha: self alpha! !

!GrowlMorph methodsFor: 'internal' stamp: 'StephaneDucasse 7/19/2011 19:27'!
openInWorld

	self position: self unoccupiedPosition.
	super openInWorld! !

!GrowlMorph methodsFor: 'internal' stamp: 'StephaneDucasse 7/19/2011 19:12'!
resetAlpha
	^ self alpha: 0.9! !

!GrowlMorph methodsFor: 'internal' stamp: 'BenjaminVanRyseghem 3/1/2012 23:34'!
resetVanishTimer

	vanishTime := TimeStamp now + self vanishDelay.
	self resetAlpha.! !

!GrowlMorph methodsFor: 'stepping' stamp: 'BenjaminVanRyseghem 3/2/2012 01:26'!
step

	(self containsPoint: ActiveHand position) ifTrue: [
		self resetAlpha.
		^ self].
	vanishTime ifNotNil: [TimeStamp now < vanishTime ifTrue: [^self]].
	self alpha: self alpha - 0.05.! !

!GrowlMorph methodsFor: 'stepping' stamp: 'TudorGirba 10/25/2011 17:15'!
stepTime
	^ 100! !

!GrowlMorph methodsFor: 'internal' stamp: 'BenjaminVanRyseghem 3/2/2012 00:10'!
streamDo: aBlock

	self contentsWrapped: (Text streamContents: aBlock).
	self extent: self minimumExtent.
	self height: (paragraph extent y + (self borderWidth * 2) + (margins ifNil: [0] ifNotNil: [margins top + margins bottom]) + 2).

	self vanishDelay: ((((self contents size /50)seconds)+1 seconds) max: self defaultVanishDelay).! !

!GrowlMorph methodsFor: 'position' stamp: 'BenjaminVanRyseghem 3/2/2012 01:11'!
unoccupiedPosition

	self class position = #bottomLeft
		ifTrue: [ ^ self unoccupiedPositionBottomLeft ].
	self class position = #topRight
		ifTrue: [ ^ self unoccupiedPositionTopRight ].
	self class position = #bottomRight
		ifTrue: [ ^ self unoccupiedPositionBottomRight ].
	self class position = #topLeft
		ifTrue: [ ^ self unoccupiedPositionTopLeft ].
	^ 0@0	
	! !

!GrowlMorph methodsFor: 'position' stamp: 'BenjaminVanRyseghem 3/2/2012 01:10'!
unoccupiedPositionBottomLeft

	| delta b morphs |
	delta := 0.
	TaskbarMorph showTaskbar
		ifTrue: [ delta := TaskbarMorph allInstances inject: 0 into: [:s :e | s + e height ]].
	b := (World bottomLeft - (0@ (self height +delta))) extent: self extent.
	morphs := self class allSubInstances select: [:m | m world == World].
	[self is: b saneWithRespectTo: morphs] whileFalse: [
		b := b translateBy: 0@(-10).
		b top < 0 ifTrue: [^ World bottomLeft - (0@ (self height +delta))]].
	^ b origin! !

!GrowlMorph methodsFor: 'position' stamp: 'BenjaminVanRyseghem 3/2/2012 01:09'!
unoccupiedPositionBottomRight

	| delta b morphs |
	delta := 0.
	TaskbarMorph showTaskbar
		ifTrue: [ delta := TaskbarMorph allInstances inject: 0 into: [:s :e | s + e height ]].
	b := (World bottomRight - (self width@ (self height +delta))) extent: self extent.
	morphs := self class allSubInstances select: [:m | m world == World].
	[self is: b saneWithRespectTo: morphs] whileFalse: [
		b := b translateBy: 0@(-10).
		b top < 0 ifTrue: [^ World bottomRight - (self width@ (self height +delta))]].
	^ b origin! !

!GrowlMorph methodsFor: 'position' stamp: 'BenjaminVanRyseghem 3/2/2012 01:11'!
unoccupiedPositionTopLeft

	| b morphs |
	b := World topLeft extent: self extent.
	morphs := self class allSubInstances select: [:m | m world == World].
	[self is: b saneWithRespectTo: morphs] whileFalse: [
		b := b translateBy: 0@10.
		b bottom > World height ifTrue: [^ World topLeft ]].
	^ b origin! !

!GrowlMorph methodsFor: 'position' stamp: 'BenjaminVanRyseghem 3/2/2012 00:47'!
unoccupiedPositionTopRight

	| b morphs |
	b := (World topRight - (self width @ 0)) extent: self extent.
	morphs := self class allSubInstances select: [:m | m world == World].
	[self is: b saneWithRespectTo: morphs] whileFalse: [
		b := b translateBy: 0@10.
		b bottom > World height ifTrue: [^ (World topRight - (self width @ 0))]].
	^ b origin! !

!GrowlMorph methodsFor: 'accessing' stamp: 'StephaneDucasse 7/19/2011 19:01'!
vanishDelay

	^ vanishDelay! !

!GrowlMorph methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/1/2012 23:31'!
vanishDelay: aDuration

	vanishDelay := aDuration.
	self resetVanishTimer! !

!GrowlMorph methodsFor: 'stepping' stamp: 'StephaneDucasse 7/19/2011 19:03'!
wantsSteps
	^ true! !

!UITheme methodsFor: '*growl' stamp: 'TudorGirba 10/25/2011 17:07'!
growlBorderColorFor: aGrowlMorph
	^ Color transparent ! !

!UITheme methodsFor: '*growl' stamp: 'TudorGirba 10/25/2011 17:07'!
growlContentsColorFor: aGrowlMorph
	^ Color white! !

!UITheme methodsFor: '*growl' stamp: 'BenjaminVanRyseghem 3/2/2012 00:08'!
growlDismissHandleFor: aGrowlMorph
	| handle form image |
	handle := EllipseMorph newBounds: ((3@3) extent: (20@20))  color: Color white.
	handle borderColor: handle color muchDarker.
	handle wantsYellowButtonMenu: false.
	form := self "haloDismissIcon" windowCloseForm.
	form ifNotNil: [
		image := ImageMorph new.
		image image: form.
		image color: handle color makeForegroundColor.
		image lock.
		handle addMorphCentered: image].
	^ handle! !

!UITheme methodsFor: '*growl' stamp: 'BenjaminVanRyseghem 3/1/2012 23:40'!
growlFillColorFor: aGrowlMorph
	^ UITheme current selectionColor! !

!UITheme methodsFor: '*growl' stamp: 'BenjaminVanRyseghem 3/2/2012 00:04'!
growlLabelColorFor: aGrowlMorph
	^ Color black lighter! !
